TARGET_EXE  = ../gdi++.exe
TARGET_DLL  = ../gdi++.dll
TARGET_DLL2 = ../gdi++.sse2.dll
TARGET_DLL3 = ../gdi++.sse3.dll

OBJ = hook.obj override.obj settings.obj cache.obj filter.obj scaleDIB_SSEoptimizedForIntelCompiler.obj
RES = gdidll.res

.SUFFIXES: .cpp .obj .objsse2 .objsse3 .rc .res

all: $(TARGET_EXE) $(TARGET_DLL)

sse: $(TARGET_DLL2) $(TARGET_DLL3)


$(TARGET_EXE): run.obj
	xlink /nologo /out:$@ run.obj

$(TARGET_DLL): $(OBJ) $(RES)
	xlink /dll /nologo /out:$@ $(OBJ) $(RES)

$(TARGET_DLL2): $(OBJ:.obj=.objsse2)
	xlink /dll /nologo /out:$@ $(OBJ:.obj=.objsse2) $(RES)

$(TARGET_DLL3): $(OBJ:.obj=.objsse3)
	xlink /dll /nologo /out:$@ $(OBJ:.obj=.objsse3) $(RES)
	

.cpp.obj:
	icl /nologo /MT /Ox /W3 /Wp64 /Fo$@ /c $<

.cpp.objsse2:
	icl /nologo /MT /Ox /W3 /Wp64 /QxP /Qipo -D__SSE2__ /Fo$@ /c $<

.cpp.objsse3:
	icl /nologo /MT /Ox /W3 /Wp64 /QxP /Qipo -D__SSE3__ /Fo$@ /c $<

.rc.res:
	rc $<


clean:
	rm -f run.obj $(TARGET_EXE) *~
	rm -f $(OBJ)  $(TARGET_DLL)
	rm -f $(OBJ:.obj=.objsse2) $(TARGET_DLL2)
	rm -f $(OBJ:.obj=.objsse3) $(TARGET_DLL3)


hook.obj: hook.cpp override.h hooklist.h
override.obj: override.cpp override.h hooklist.h
run.obj: run.cpp
